<?PHP
##################################################
# Мерчант Payeer для скриптов Фруктовая Ферма    #
# Автор: Администратор PSWeb.ru                  #
# Сайт: psweb.ru                                 #
# email: i@psweb.ru                              #
##################################################

//Проверка IP сервера оповещений Payeer
if (!in_array($_SERVER['REMOTE_ADDR'], array('185.71.65.92', '185.71.65.189', '149.202.17.210'))) die('ERROR IP');

// проверка на наличие обязательных полей
	foreach(array(
		'm_operation_id',
		'm_operation_ps',
		'm_operation_date',
		'm_operation_pay_date',
		'm_shop',
		'm_orderid',
		'm_amount',
		'm_curr',
		'm_desc',
		'm_status'
	) as $field) {
		if(empty($_POST[$field])) {
			if (isset($_POST['m_orderid']))
			{
				die($_POST['m_orderid'].'|error');
			}
			else die ('DATA ERROR');
		}
	}
	
	// Автоподгрузка классов
	function __autoload($name){ include('classes/_class.'.$name.'.php');}

	// Класс конфига 
	$config = new config;

	// Функции
	$func = new func;

	// База данных
	$db = new db($config->HostDB, $config->UserDB, $config->PassDB, $config->BaseDB);

	$m_key = $config->secretW; //секретное слово
	
	// Массив данных
	$arHash = array($_POST['m_operation_id'],
			$_POST['m_operation_ps'],
			$_POST['m_operation_date'],
			$_POST['m_operation_pay_date'],
			$_POST['m_shop'],
			$_POST['m_orderid'],
			$_POST['m_amount'],
			$_POST['m_curr'],
			$_POST['m_desc'],
			$_POST['m_status'],
			$m_key);
	
	$sign_hash = strtoupper(hash('sha256', implode(':', $arHash))); // формируем подпись
	
	if ($_POST['m_sign'] == $sign_hash && $_POST['m_status'] == 'success') // Проверка подписи из оповещения сервера Payeer
	{
		$db->Query("SELECT * FROM db_payeer_insert WHERE id = ".$_POST['m_orderid']) or die ($_POST['m_orderid'].'|error'); // Информация о платеже
		if($db->NumRows() == 0){ die ($_POST['m_orderid'].'|error');} // Ошибка, если платежа нет в базе
	
		$payeer_row = $db->FetchArray(); // Массив данных о платеже из базы
		if($payeer_row['status'] > 0){ die ($_POST['m_orderid'].'|success');} // Проверка не является ли платеж уже оплаченным
		if($payeer_row['sum'] != $_POST['m_amount']){ die ($_POST['m_orderid'].'|error');} // Проверка суммы платежа
		$payment_amount = $payeer_row['sum'];
		$user_id = $payeer_row['user_id'];
   
		# Настройки
		$db->Query("SELECT * FROM db_config WHERE id = '1' LIMIT 1") or die ($_POST['m_orderid'].'|error');
		$config_site = $db->FetchArray();
   
		$db->Query("SELECT user, referer_id FROM db_users_a WHERE id = '$user_id' LIMIT 1") or die ($_POST['m_orderid'].'|error');
		$user_ardata = $db->FetchArray();
		$user_name = $user_ardata['user'];
		$refid = $user_ardata['referer_id'];
   
		// Зачисляем баланс
		$serebro = sprintf("%.4f", floatval($config_site['ser_per_wmr'] * $payment_amount) );
   
		$db->Query("SELECT insert_sum FROM db_users_b WHERE id = '$user_id' LIMIT 1") or die ($_POST['m_orderid'].'|error');
		$ins_sum = $db->FetchRow();
   
		$serebro = intval($ins_sum <= 0.01) ? ($serebro + ($serebro * 0.55) ) : $serebro; //Бонус при первом пополнении
		$add_tree = ( $payment_amount >= 499.99) ? 2 : 0; // Дерево/фрукт при пополнении на определенную сумму
		$lsb = time();
		$to_referer = ($serebro * 0.10); // Отчисления рефералу
		// Зачисляем пользователю
		$db->Query("UPDATE db_users_b SET money_b = money_b + '$serebro', e_t = e_t + '$add_tree', to_referer = to_referer + '$to_referer', last_sbor = '$lsb', insert_sum = insert_sum + '$payment_amount' WHERE id = '$user_id'") or die ($_POST['m_orderid'].'|error');
		$db->Query("UPDATE db_payeer_insert SET status = '1' WHERE id = '".$_POST['m_orderid']."'") or die(mysql_error());
		// Зачисляем средства рефереру и дерево
		$add_tree_referer = ($ins_sum <= 0.01) ? ", a_t = a_t + 1" : "";
		$db->Query("UPDATE db_users_b SET money_b = money_b + $to_referer, from_referals = from_referals + '$to_referer' $add_tree_referer WHERE id = '$refid'") or die(mysql_error());
   
		// Статистика пополнений
		$da = time();
		$dd = $da + 60*60*24*15;
		$db->Query("INSERT INTO db_insert_money (user, user_id, money, serebro, date_add, date_del) VALUES ('$user_name','$user_id','$payment_amount','$serebro','$da','$dd')") or die(mysql_error());
   
		// Конкурс
		$competition = new competition($db);
		$competition->UpdatePoints($user_id, $payment_amount);
		/////////////////////////////////////////////////////////
		
		// WMSET
		$wmset = new wmset();
		$marray = $wmset->GetSet($payment_amount);
		$a_t = intval($marray['t_a']);
		$b_t = intval($marray['t_b']);
		$c_t = intval($marray['t_c']);
		$d_t = intval($marray['t_d']);
		$e_t = intval($marray['t_e']);
   
		$db->Query("UPDATE db_users_b SET a_t = a_t + '$a_t', b_t = b_t + '$b_t', c_t = c_t + '$c_t', d_t = d_t + '$d_t', e_t = e_t + '$e_t', last_sbor = '$lsb' WHERE id = '$user_id'") or die(mysql_error());
		
		// Платежные баллы
		$pp = new pay_points($db);
		$pp ->UpdatePayPoints($payment_amount,$user_id);
	
		// Обновление статистики сайта
		$db->Query("UPDATE db_stats SET all_insert = all_insert + '$payment_amount' WHERE id = '1'") or die(mysql_error());
		die ($_POST['m_orderid'].'|success');
	}
	die ($_POST['m_orderid'].'|error');
?>